library(tidyverse)
library(ggplot2)
library(reshape2)
library(RColorBrewer)
library(ggdist)
library(shades)
library(viridis)
require(gridExtra)

#####################################
########  prepare some data  ########
#####################################

#####benthos##########
specnames_benthos <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\spenames_bs.rds")
specnames_benthos <- chartr(".", " ", specnames_benthos)
specnames_benthos2 <- specnames_benthos[c(1,2,5:20,24)]

sal_zone <- c("Sterk polyhalien","Zwak polyhalien","Mesohalien")
#load("C:\\Users\\xwu\\R_working\\workspace2\\QuanReg\\output\\predict_grainsize\\model_d50_em.Rdata")
load("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\predict_grainsize\\modlm_d50_low.Rdata")

result_benthos <- read.csv("./output/result_data/benthos_zone/0926/ssc1/1000/100years/lowdynam/median_bs_sal1_spe1.csv")


# #####plant##########
specnames_plant <- c("Spartina anglica","Elymus pycnanthus","Phragmites australis","Triglochin maritima","Halimione portulacoides","Scirpus maritimus","Puccinellia maritima",
                     "Plantago maritima","Aster tripolium","Atriplex prostrata","Festuca rubra","Glaux maritim","Limonium vulgare","Spergularia media",
                     "Salicornia europaea","Suaeda maritima","Cochlearia officinalis")
#saveRDS(specnames_plant,"C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\Prediction\\script\\shared\\specnames_plant.rds")

sal_zone <- c("Sterk polyhalien","Zwak polyhalien","Mesohalien")
# 
result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc3/1000/100years/lowdynam/plant_median_sal3_spe1.csv"))

########################
########  plot  ########
########################

for(l in 1:3){#ssc
  for(i in 1:length(sal_zone)){#salzone
    #fixed color
    color_benthos <- readRDS(paste0("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\color_benthos_global.rds"))
    color_plant <- readRDS(paste0("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\color_plant_global.rds"))
    color <- append(color_benthos,color_plant)
    name_order_b <- readRDS(paste0("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\name_high_order_benthos_sal",i,".rds"))###slope  high
    name_order_p <- readRDS(paste0("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\name_high_order_plant_sal",i,".rds"))
    name_order <- append(name_order_b,name_order_p)
    
    for(k in c(20,50,100)){#Time 50 years & 100 years later
      #benthos
      result_benthos_tran <- data.frame(matrix(NA, nrow = ncol(result_benthos), ncol =length(specnames_benthos2)))
      result_benthos_occur_tran <- data.frame(matrix(NA, nrow = ncol(result_benthos), ncol =length(specnames_benthos2)))
      result_benthos_cv_tran <- data.frame(matrix(NA, nrow = ncol(result_benthos), ncol =length(specnames_benthos2)))
      
      colnames(result_benthos_tran)<-specnames_benthos2
      colnames(result_benthos_occur_tran)<-specnames_benthos2
      colnames(result_benthos_cv_tran)<-specnames_benthos2
      
      #plant
      result_plant_tran <- data.frame(matrix(NA, nrow = ncol(result_plant), ncol =length(specnames_plant)))
      result_plant_occur_tran <- data.frame(matrix(NA, nrow = ncol(result_plant), ncol =length(specnames_plant)))
      
      
      colnames(result_plant_tran)<-specnames_plant
      colnames(result_plant_occur_tran)<-specnames_plant
      
      #benthos
      for(j in c(1,2,5:20,24)){
        # result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slope/median_bs_sal", i,"_spe",j,".csv"))
        # result_benthos_occur <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slope/occur_bs_sal", i,"_spe",j,".csv"))
        # result_benthos_cv<- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slope/cv_bs_sal", i,"_spe",j,".csv"))
        
        # result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000/median_bs_sal", i,"_spe",j,".csv"))
        # result_benthos_occur <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000/occur_bs_sal", i,"_spe",j,".csv"))
        # result_benthos_cv<- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000/cv_bs_sal", i,"_spe",j,".csv"))
        
        # result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_ele/median_bs_sal", i,"_spe",j,"_1.csv"))
        # result_benthos_occur <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_ele/occur_bs_sal", i,"_spe",j,"_1.csv"))
        # result_benthos_cv<- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_ele/cv_bs_sal", i,"_spe",j,"_1.csv"))
        
        #slr0
        #result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slr0/median_bs_sal", i,"_spe",j,".csv"))
        #result_benthos_occur <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slr0/occur_bs_sal", i,"_spe",j,".csv"))
        #result_benthos_cv<- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slr0/cv_bs_sal", i,"_spe",j,".csv"))
        
        #slr0 slope
        result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slope_slr0/median_bs_sal", i,"_spe",j,".csv"))
        result_benthos_occur <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slope_slr0/occur_bs_sal", i,"_spe",j,".csv"))
        result_benthos_cv<- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slope_slr0/cv_bs_sal", i,"_spe",j,".csv"))
        
        result_benthos_tran[specnames_benthos[j]] <- as.numeric(as.vector(result_benthos[k,]))
        result_benthos_occur_tran[specnames_benthos[j]] <- as.numeric(as.vector(result_benthos_occur[k,]))
        result_benthos_cv_tran[specnames_benthos[j]] <- as.numeric(as.vector(result_benthos_cv[k,]))
      }
      
      result_benthos_tran <- result_benthos_tran[,name_order_b]
      result_benthos_tran <- select_if(result_benthos_tran,function(col) max(col)>0.1)
      result_benthos_occur_tran <- result_benthos_occur_tran[colnames(result_benthos_tran)]
      result_benthos_cv_tran<- result_benthos_cv_tran[colnames(result_benthos_tran)]
      
      total_biomass_benthos <- data.frame(elevation=seq(0,1000,length.out=ncol(result_benthos)),total=rowSums(result_benthos_tran))[1:200,]
      index_benthos <- which(total_biomass_benthos$total>0.5)
      total_biomass_benthos <- total_biomass_benthos[index_benthos,]
      total_biomass_benthos <- total_biomass_benthos %>% 
        add_row(elevation = length(index_benthos)*5, total=0)
      
      richness_benthos <- data.frame(elevation=seq(0,1000,length.out=ncol(result_benthos_cv)),richness=rowSums(result_benthos_occur_tran))
      richness_benthos <- richness_benthos[index_benthos,]
      richness_benthos <- richness_benthos %>% 
        add_row(elevation = length(index_benthos)*5, richness=0)
      
      
      result_benthos_tran$elevation<-seq(0,1000,length.out=ncol(result_benthos))
      result_benthos_occur_tran$elevation<-seq(0,1000,length.out=ncol(result_benthos))
      result_benthos_cv_tran$elevation<-seq(0,1000,length.out=ncol(result_benthos))#2000=(length(em_t)-1)*5  401=length(em_t)
      
      result_benthos_tran <- result_benthos_tran[index_benthos,]
      result_benthos_tran[nrow(result_benthos_tran) + 1,] <- c(rep(0,ncol(result_benthos_tran)-1),length(index_benthos)*5)
      result_benthos_occur_tran <- result_benthos_occur_tran[index_benthos,]
      result_benthos_occur_tran[nrow(result_benthos_occur_tran) + 1,] <- c(rep(0,ncol(result_benthos_occur_tran)-1),length(index_benthos)*5)
      
      
      #plant
      for(j in 1:17){
        # result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000/100years/lowdynam/plant_median_sal", i,"_spe",j,".csv"))
        # result_plant_occur <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000/100years/lowdynam/plant_occur_sal", i,"_spe",j,".csv"))
        
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000/plant_median_sal", i,"_spe",j,".csv"))
        #result_plant_occur <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000/plant_occur_sal", i,"_spe",j,".csv"))
        
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000_slope/plant_median_sal", i,"_spe",j,".csv"))
        #result_plant_occur <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000_slope/plant_occur_sal", i,"_spe",j,".csv"))
        
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000_ele/plant_median_sal", i,"_spe",j,"_1.csv"))
        #result_plant_occur <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000_ele/plant_occur_sal", i,"_spe",j,"_1.csv"))
        #slr0
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000_slr0/plant_median_sal", i,"_spe",j,".csv"))
        #result_plant_occur <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000_slr0/plant_occur_sal", i,"_spe",j,".csv"))
        
        #slr0 slope
        result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000_slope_slr0/plant_median_sal", i,"_spe",j,".csv"))
        result_plant_occur <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", l,"/1000_slope_slr0/plant_occur_sal", i,"_spe",j,".csv"))
        
        
        result_plant_tran[specnames_plant[j]] <- as.numeric(as.vector(result_plant[k,]))
        result_plant_occur_tran[specnames_plant[j]] <- as.numeric(as.vector(result_plant_occur[k,]))
      }
      
      result_plant_tran <- result_plant_tran[,name_order_p]
      result_plant_tran <- select_if(result_plant_tran,function(col) max(col)>0.1)
      result_plant_occur_tran <- result_plant_occur_tran[colnames(result_plant_tran)]
      
      total_biomass_plant <- data.frame(elevation=seq(0,1000,length.out=ncol(result_plant)),total=rowSums(result_plant_tran))
      index_plant <- which(total_biomass_plant$total>0)
      total_biomass_plant <- total_biomass_plant[c(min(index_plant)-1,index_plant),]
      total_biomass_plant <- filter(total_biomass_plant,elevation!=1000)
      
      richness_plant <- data.frame(elevation=seq(0,1000,length.out=ncol(result_plant_occur)),richness=rowSums(result_plant_occur_tran))
      richness_plant <- richness_plant[c(min(index_plant)-1,index_plant),]
      richness_plant <- filter(richness_plant,elevation!=1000)
      
      result_plant_tran$elevation<-seq(0,1000,length.out=ncol(result_plant))
      result_plant_occur_tran$elevation<-seq(0,1000,length.out=ncol(result_plant))
      result_plant_tran <- result_plant_tran[c(min(index_plant)-1,index_plant),]
      result_plant_occur_tran <- result_plant_occur_tran[c(min(index_plant)-1,index_plant),]
      
      data_benthos <- melt(result_benthos_tran,id='elevation')
      data_benthos_occur <-melt(result_benthos_occur_tran,id='elevation') 
      data_benthos_cv <-melt(result_benthos_cv_tran,id='elevation')
      
      
      result_plant_tran <- filter(result_plant_tran,elevation!=1000)
      result_plant_occur_tran <- filter(result_plant_occur_tran,elevation!=1000)
      data_plant <- melt(result_plant_tran,id='elevation')
      data_plant_occur <-melt(result_plant_occur_tran,id='elevation')
      coeff <- 125
      coeff_total <- 60
      
      #Biomass
      p1 <- ggplot() + 
        geom_line(data_benthos, mapping=aes(elevation, value, group = variable,col=variable),size=1.5)+
        geom_line(data_plant, mapping=aes(elevation, value/coeff, group = variable,col=variable),size=1.5,linetype = "dotdash")+
        scale_y_continuous(
          limits = c(0, 6),  
          # Features of the first axis
          name = expression(paste("Biomass(g AFDW ", m^-2,")")),
          
          # Add a second axis and specify its features
          sec.axis = sec_axis(~.*coeff, name=expression(paste("Biomass(g ", m^-2,")")))
        )+
        scale_x_continuous(
          name = "Distance from the sea (m)",
        )+
        scale_colour_manual(values=color,name=" ",breaks=name_order)+
        theme_classic()+
        theme(
          axis.text = element_text(size = 45),
          axis.title.y = element_text( size=45,margin = margin(t = 1, r = 12, b = 0, l = 0)),
          axis.title.x = element_text(size=45,margin = margin(t = 12, r = 0, b = 0, l = 0)),
          axis.title.y.right = element_text(size=45,margin = margin(t = 1, r =0 , b = 0, l = 12)),
          legend.position = "none",
          #plot.margin = unit(c(2,2,2,2), "cm")
          #plot.title = element_text(size = 17,hjust = 0.5),
          legend.text = element_text(size = 20,face = "italic")
        )
      
      p2 <- ggplot() + 
        geom_line(total_biomass_benthos, mapping=aes(elevation, total,colour="Total biomass of benthos"),size=1.5)+
        geom_line(total_biomass_plant, mapping=aes(elevation, total/coeff_total,colour="Total biomass of plant"),size=1.5,linetype = "dotdash")+
        scale_y_continuous(
          limits = c(0, 25),  
          # Features of the first axis
          breaks=c(0,25),
          name = " ",
          
          # Add a second axis and specify its features
          sec.axis = sec_axis(~.*coeff_total, name=" ",breaks=c(0,1250),)
        )+
        scale_x_continuous(
          name = "Distance from the sea (m)",
        )+
        scale_colour_manual(values=c("Total biomass of benthos" ="#3399FF", "Total biomass of plant" = "#009966"),name=" ")+
        theme_classic()+
        theme(
          axis.text.x = element_blank(),
          axis.text.y = element_text(size = 45),
          axis.title.x = element_blank(),
          axis.title.y = element_text( size=45,margin = margin(t = 0, r = 12, b = 0, l = 0)),
          axis.ticks.x = element_blank(),
          plot.margin = unit(c(0.5,0.4,0.8,0.1), "cm"),
          legend.position = "none",
          legend.text = element_text(size = 20)
        )
      p <- grid.arrange(p2,p1, heights=c(1/4, 3/4), ncol=1, nrow=2)
      
      #occurrence
      p_occur1 <- ggplot() + 
        geom_line(data_benthos_occur, mapping=aes(elevation, value, group = variable,col=variable),size=1.5)+
        geom_line(data_plant_occur, mapping=aes(elevation, value, group = variable,col=variable),size=1.5,linetype = "dotdash")+
        scale_y_continuous(
          limits = c(0, 1),  
          name = "Probablity of occurrence",
        )+
        scale_x_continuous(
          name = "Distance from the sea (m)",
        )+
        scale_colour_manual(values=color,name=" ",breaks=name_order)+
        theme_classic()+
        theme(
          axis.text = element_text(size = 45),
          axis.title.y = element_text( size=45,margin = margin(t = 0, r = 12, b = 0, l = 0)),
          axis.title.x = element_text(size=45,margin = margin(t = 12, r = 0, b = 0, l = 0)),
          axis.title.y.right = element_text(size=45,margin = margin(t = 0, r =0 , b = 30, l = 12)),
          legend.position = "none",
        ) 
      p_occur2 <- ggplot() + 
        geom_line(richness_benthos, mapping=aes(elevation, richness),col="#3399FF",size=1.5)+
        geom_line(richness_plant, mapping=aes(elevation, richness),col="#00CC33",size=1.5,linetype = "dotdash")+
        scale_y_continuous(
          limits = c(0, 15),  
          breaks=c(0,15),
          name = " ",
        )+
        scale_x_continuous(
          name = "Distance from the sea (m)",
        )+
        theme_classic()+
        theme(
          axis.text.x = element_blank(),
          axis.text.y = element_text(size = 45),
          axis.title.x = element_blank(),
          axis.title.y = element_text( size=45,margin = margin(t = 0, r = 12, b = 0, l = 0)),
          axis.ticks.x = element_blank(),
          plot.margin = unit(c(0.5,0.4,0.8,1.5), "cm")
        )
      p_occur <- grid.arrange(p_occur2,p_occur1, heights=c(1/4, 3/4), ncol=1, nrow=2)
      
      #ggsave(p, file=paste0("./output/result/pred_bs_sal", i,"_time",k,".png"), width = 20, height = 14, units = "cm")
      #ggsave(p_occur, file=paste0("./output/result/pred_occur_bs_sal", i,"_time",k,".png"), width = 20, height = 14, units = "cm")
      
      #ggsave(p, file=paste0("./output/result_figure/together/1121/ssc", l,"/1000_slope/pred_bs_slr2_ssc", l,"_sal", i,"_time",k,".png"), width = 45, height = 30, units = "cm")
      #ggsave(p_occur, file=paste0("./output/result_figure/together/1121/ssc", l,"/1000_slope/pred_occur_bs_slr2_ssc", l,"_sal", i,"_time",k,".png"), width = 45, height = 30, units = "cm")
      
      #ggsave(p, file=paste0("./output/result_figure/together/1121/ssc", l,"/1000/pred_bs_slr2_ssc", l,"_sal", i,"_time",k,".png"), width = 45, height = 30, units = "cm")
      #ggsave(p_occur, file=paste0("./output/result_figure/together/1121/ssc", l,"/1000/pred_occur_bs_slr2_ssc", l,"_sal", i,"_time",k,".png"), width = 45, height = 30, units = "cm")
      
      #ggsave(p, file=paste0("./output/result_figure/together/1121/ssc", l,"/1000_ele/pred_bs_slr2_ssc", l,"_sal", i,"_time",k,"_1.png"), width = 45, height = 30, units = "cm")
      #ggsave(p_occur, file=paste0("./output/result_figure/together/1121/ssc", l,"/1000_ele/pred_occur_bs_slr2_ssc", l,"_sal", i,"_time",k,"_1.png"), width = 45, height = 30, units = "cm")
      
      #slr0
      #ggsave(p, file=paste0("./output/result_figure/together/1121/ssc", l,"/1000_slr0/pred_bs_slr2_ssc", l,"_sal", i,"_time",k,".png"), width = 45, height = 30, units = "cm")
      #ggsave(p_occur, file=paste0("./output/result_figure/together/1121/ssc", l,"/1000_slr0/pred_occur_bs_slr2_ssc", l,"_sal", i,"_time",k,".png"), width = 45, height = 30, units = "cm")
      
      #slr0 slope
      ggsave(p, file=paste0("./output/result_figure/together/1121/ssc", l,"/1000_slope_slr0/pred_bs_slr0_ssc", l,"_sal", i,"_time",k,".png"), width = 45, height = 30, units = "cm")
      ggsave(p_occur, file=paste0("./output/result_figure/together/1121/ssc", l,"/1000_slope_slr0/pred_occur_bs_slr0_ssc", l,"_sal", i,"_time",k,".png"), width = 45, height = 30, units = "cm")
    }
  }
}

#output legend
library("cowplot")
g_legend<-function(a.gplot){
  tmp <- ggplot_gtable(ggplot_build(a.gplot))
  leg <- which(sapply(tmp$grobs, function(x) x$name) == "guide-box")
  legend <- tmp$grobs[[leg]]
  legend
}

legend <- g_legend(p1)
ggsave(legend, file="./output/result_figure/together/legend1.png", width = 50, height = 10, units = "cm")
