library(ggplot2)
library(RColorBrewer)

#############################
########  Elevation  ########
#############################

for(j in 1:3){#ssc
  for(i in 1:3){#sal
    #eval(parse(text = paste0('Z_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000/Z_zone',i,'_ssc',j,'_slr2.csv",stringsAsFactors = F)')))
    #eval(parse(text = paste0('Z_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000_ele/Z_zone',i,'_ssc',j,'_slr2_1.csv",stringsAsFactors = F)')))
    eval(parse(text = paste0('Z_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000_slope/Z_zone',i,'_ssc',j,'_slr0.csv",stringsAsFactors = F)')))
    
    elevation <- data.frame(matrix(NA, nrow =(ncol(Z_pre)-1) , ncol =4))
    elevation$X1 <- as.numeric(as.vector(Z_pre[1,2:202]))
    elevation$X2 <- as.numeric(as.vector(Z_pre[121,2:202]))
    elevation$X3 <- as.numeric(as.vector(Z_pre[301,2:202]))
    elevation$X4 <- as.numeric(as.vector(Z_pre[602,2:202]))
    elevation$elevation<-seq(0,1000,length.out=ncol(Z_pre)-1)

    color <- brewer.pal(11,'BrBG')
    ssc1Color <- color[2]
    ssc2Color <- color[3]
    ssc3Color <- color[4]
    ssc4Color <- color[5]
    
    
    p <- ggplot(elevation,aes(x=elevation)) +
      geom_ribbon(aes(ymin=-2,ymax=X4, fill="100 years"),stat="identity") +
      geom_ribbon(aes(ymin=-2,ymax=X3, fill="50 years"),stat="identity") +
      geom_ribbon(aes(ymin=-2,ymax=X2, fill="20 years"),stat="identity") +
      geom_ribbon(aes(ymin=-2,ymax=X1, fill="Initial conf."),stat="identity") + 
      
      scale_fill_manual(name = " ",values = c("Initial conf." =ssc1Color, "20 years" = ssc2Color,"50 years" = ssc3Color,"100 years" = ssc4Color),
                        breaks=c('Initial conf.', '20 years', '50 years', '100 years'))+
      
      scale_y_continuous(
        limits = c(-2, 4),
        name = "Elevation(m)"
      )+
      scale_x_continuous(
        name = "Distance from the sea (m)"
      )+
      theme_classic()+
      
      theme(
        axis.text = element_text(size = 48),
        axis.title.y = element_text( size=48,margin = margin(t = 0, r = 10, b = 0, l = 0)),
        axis.title.x = element_text(size=48,margin = margin(t = 10, r = 0, b = 0, l = 0)),
        #plot.title = element_text(size = 17,hjust = 0.5),
        legend.position = "none",
        legend.text = element_text(size = 48),
      )
    
    #ggsave(p, file=paste0("./output/result_figure/elevation/0926/1000/elevation_area_sal",i,"_ssc",j,"_slr2.png"), width = 45, height = 30, units = "cm")
    #ggsave(p, file=paste0("./output/result_figure/elevation/0926/1000_ele/elevation_area_sal",i,"_ssc",j,"_1.png"), width = 45, height = 30, units = "cm")
    ggsave(p, file=paste0("./output/result_figure/elevation/0926/1000_slope/elevation_area_sal",i,"_ssc",j,"_slr0.png"), width = 45, height = 30, units = "cm")
  }}

g_legend<-function(a.gplot){
  tmp <- ggplot_gtable(ggplot_build(a.gplot))
  leg <- which(sapply(tmp$grobs, function(x) x$name) == "guide-box")
  legend <- tmp$grobs[[leg]]
  legend
}


legend <- g_legend(p)
ggsave(legend, file="./output/result_figure/elevation/0926/legend.png", width = 8, height = 8, units = "cm")



##############################
########  Inundation  ########
##############################

for(j in 1:3){#ssc
  for(i in 1:3){#sal
    #eval(parse(text = paste0('Z_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000/T_zone',i,'_ssc',j,'_slr2.csv",stringsAsFactors = F)')))
    #eval(parse(text = paste0('Z_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000_ele/T_zone',i,'_ssc',j,'_slr2_1.csv",stringsAsFactors = F)')))
    eval(parse(text = paste0('Z_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000_slope/T_zone',i,'_ssc',j,'_slr0.csv",stringsAsFactors = F)')))
    elevation <- data.frame(matrix(NA, nrow =(ncol(Z_pre)-2) , ncol =4))#length(seq(1,201))
    elevation$X1 <- as.numeric(as.vector(Z_pre[1,2:201]))
    elevation$X2 <- as.numeric(as.vector(Z_pre[121,2:201]))
    elevation$X3 <- as.numeric(as.vector(Z_pre[301,2:201]))
    elevation$X4 <- as.numeric(as.vector(Z_pre[601,2:201]))
    elevation$elevation<-seq(0,1000,length.out=ncol(Z_pre)-2)

    color <- brewer.pal(9,'Blues')
    ssc1Color <- color[3]
    ssc2Color <- color[4]
    ssc3Color <- color[5]
    ssc4Color <- color[6]
    
    
    p <- ggplot(elevation,aes(x=elevation)) +
      geom_ribbon(aes(ymin=0,ymax=X1, fill="Initial conf."),stat="identity",alpha = 0.5) +
      geom_ribbon(aes(ymin=0,ymax=X2, fill="20 years"),stat="identity",alpha = 0.5) +
      geom_ribbon(aes(ymin=0,ymax=X3, fill="50 years"),stat="identity",alpha = 0.5) +
      geom_ribbon(aes(ymin=0,ymax=X4, fill="100 years"),stat="identity",alpha = 0.5) +
      
      scale_fill_manual(name = " ",values = c("Initial conf." =ssc1Color, "20 years" = ssc2Color,"50 years" = ssc3Color,"100 years" = ssc4Color),
                        breaks=c('Initial conf.', '20 years', '50 years', '100 years'))+
      
      scale_y_continuous(
        limits = c(0, 1),
        name = "Inundation ratio"
      )+
      scale_x_continuous(
        name = "Distance from the sea (m)"
      )+
      theme_classic()+
      
      theme(
        axis.text = element_text(size = 48),
        axis.title.y = element_text( size=48,margin = margin(t = 0, r = 10, b = 0, l = 0)),
        axis.title.x = element_text(size=48,margin = margin(t = 10, r = 0, b = 0, l = 0)),
        #plot.title = element_text(size = 17,hjust = 0.5),
        legend.position = "none",
        legend.text = element_text(size = 30),
      )

    #ggsave(p, file=paste0("./output/result_figure/elevation/0926/1000/inundation_area_sal",i,"_ssc",j,"_slr2.png"), width = 45, height = 30, units = "cm")
    #ggsave(p, file=paste0("./output/result_figure/elevation/0926/1000_ele/inundation_area_sal",i,"_ssc",j,"_1.png"), width = 45, height = 30, units = "cm")
    ggsave(p, file=paste0("./output/result_figure/elevation/0926/1000_slope/inundation_area_sal",i,"_ssc",j,"_slr0.png"), width = 45, height = 30, units = "cm")
  }}

g_legend<-function(a.gplot){
  tmp <- ggplot_gtable(ggplot_build(a.gplot))
  leg <- which(sapply(tmp$grobs, function(x) x$name) == "guide-box")
  legend <- tmp$grobs[[leg]]
  legend
}


legend <- g_legend(p)
ggsave(legend, file="./output/result_figure/elevation/0926/legend_inundation.png", width = 8, height = 8, units = "cm")
