
#####Ridgeline plots####
library(tidybayes)
library(ggplot2)
library(posterior)
library(reshape2)
library(RColorBrewer)
library(ggdist)
library(ggridges)
library(tidyverse)
require(gridExtra)


specnames_benthos <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\spenames_bs.rds")
specnames_benthos <- chartr(".", " ", specnames_benthos)
specnames_plant <- c("Spartina anglica","Elymus pycnanthus","Phragmites australis","Triglochin maritima","Halimione portulacoides","Scirpus maritimus","Puccinellia maritima",
                     "Plantago maritima","Aster tripolium","Atriplex prostrata","Festuca rubra","Glaux maritim","Limonium vulgare","Spergularia media",
                     "Salicornia europaea","Suaeda maritima","Cochlearia officinalis")
specnames_benthos2 <- specnames_benthos[c(1,2,5:20,24)]

load("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\predict_grainsize\\modlm_d50_high.Rdata")
load("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\predict_grainsize\\modlm_d50_low.Rdata")

ele_seq <- rev(seq(0,1,0.01))
d50_seq_F=as.numeric(predict(modlm_d50_high,data.frame(em=ele_seq)))
d50_seq_TP=as.numeric(predict(modlm_d50_low,data.frame(em=ele_seq)))#slope high



sal_zone <- c("Sterk polyhalien","Zwak polyhalien","Mesohalien")
para_total <- data.frame(c(-8.6744,-7.810,-11.1413),
                         c(0.5378,0.6,0.66))

##########functions###################
Time_to_fre1 <- function(inun_time){
  m=701
  H=2.21
  Ta=2.25
  ele <- 0-Ta*cos(pi-pi*inun_time)
  Fre <- m/(1+exp(5.648*(ele-H)))
  return(Fre)
}
Time_to_fre2 <- function(inun_time){
  m=703
  H=2.38
  Ta=2.5
  ele <- 0-Ta*cos(pi-pi*inun_time)
  Fre <- m/(1+exp(5.648*(ele-H)))
  return(Fre)
}
Time_to_fre3 <- function(inun_time){
  m=705
  H=2.65
  Ta=2.75
  ele <- 0-Ta*cos(pi-pi*inun_time)
  Fre <- m/(1+exp(5.648*(ele-H)))
  return(Fre)
}
g_legend<-function(a.gplot){
  tmp <- ggplot_gtable(ggplot_build(a.gplot))
  leg <- which(sapply(tmp$grobs, function(x) x$name) == "guide-box")
  legend <- tmp$grobs[[leg]]
  legend
}
# creating Standardization function 
standardize = function(x){ 
  z <- (x-min(x))/(max(x)-min(x))#(x - mean(x)) / sd(x) 
  return( z) 
}

Prop_calculation = function(x){ 
  z <- x/sum(x)#(x - mean(x)) / sd(x) 
  return(z) 
} 

for(i in 1:3){#sal
  
  ############################################################  Foreshore  ####################################################################
  d50_seq <- d50_seq_F
  #######preparing plot data#################
  data_benthos_biomass <- data.frame(matrix(NA, nrow = length(ele_seq), ncol =length(specnames_benthos2)))
  colnames(data_benthos_biomass) <- specnames_benthos2
  
  
  data_benthos_occur <- data.frame(matrix(NA, nrow = length(ele_seq), ncol =length(specnames_benthos2)))
  colnames(data_benthos_occur) <- specnames_benthos2 
  
  data_plant_biomass <- data.frame(matrix(NA, nrow = length(ele_seq), ncol =length(specnames_plant)))
  colnames(data_plant_biomass) <- specnames_plant
  
  
  data_plant_occur <- data.frame(matrix(NA, nrow = length(ele_seq), ncol =length(specnames_plant)))
  colnames(data_plant_occur) <- specnames_plant
  
  #benthos
  for(j in c(1,2,5:20,24)){
    eval(parse(text = paste0('load("C:/Users/xwu/R_working/workspace2/ecology model/output/model/model_bs_benthos1026/model_hurdle_salzone_bs_',j,'.Rdata")')))
    tidy_epred_benthos <- model_hurdle_salzone_bs %>% 
      epred_draws(newdata = data.frame(d50=d50_seq,em= ele_seq,salzone=sal_zone[i]),re_formula = ~ (em + d50|salzone))
    posterior_epred_benthos <- tidy_epred_benthos %>% 
      group_by(.row) %>% 
      summarise(median=median(.epred),quan95= quantile(.epred, 0.95),mean=mean(.epred),sd=sd(.epred)) %>% 
      mutate(cv=sd / mean)
    #occurrence
    tidy_prediction_benthos <- model_hurdle_salzone_bs %>% 
      predicted_draws(newdata = data.frame(d50=d50_seq,em= ele_seq,salzone=sal_zone[i]),re_formula = ~ (em + d50|salzone))
    posterior_occur_benthos <- tidy_prediction_benthos %>% 
      group_by(.row) %>% 
      summarise(prob=sum(.prediction>0.00001)/8000)
    
    data_benthos_biomass[specnames_benthos[j]] <- posterior_epred_benthos$median
    data_benthos_occur[specnames_benthos[j]] <- posterior_occur_benthos$prob
  }
  #species filtering
  data_benthos_biomass <- select_if(data_benthos_biomass,function(col) max(col)>0.1)
  data_benthos_occur <- select_if(data_benthos_occur,function(col) max(col)>0.1)
  name_select_benthos <- intersect(colnames(data_benthos_biomass),colnames(data_benthos_occur))
  data_benthos_biomass <- data_benthos_biomass[,name_select_benthos]
  data_benthos_occur <- data_benthos_occur[,name_select_benthos]
  

  data_benthos_biomass$`Total biomass` <-apply(data_benthos_biomass, 1, function(x) {exp(mean(log(x+1)))-1})
  data_benthos_occur$Richness <- rowSums(data_benthos_occur)
 
  
  #plant
  eval(parse(text = paste0('inun_seq <- sapply(ele_seq,Time_to_fre',i,')')))
  for(m in 1:length(specnames_plant)){
    eval(parse(text = paste0('load("C:/Users/xwu/R_working/workspace2/ecology model/output/model/model_bs_plant/ele/model_hurdle_plant_bs_',m,'.Rdata")')))
    #abundance
    tidy_epred_plant <- model_hurdle_fit %>% 
      epred_draws(newdata = data.frame(ELEVATION=inun_seq,salzone=sal_zone[i]))
    tidy_epred_plant$.epred[tidy_epred_plant$.epred<0.00001]=0
    posterior_epred_plant <- tidy_epred_plant %>% 
      group_by(.row) %>% 
      summarise(median=median(.epred),quan95= quantile(.epred, 0.95),mean=mean(.epred),sd=sd(.epred)) %>% 
      mutate(cv=sd / mean)
    
    #occurrence
    tidy_prediction_plant <- model_hurdle_fit %>% 
      predicted_draws(newdata = data.frame(ELEVATION=inun_seq,salzone=sal_zone[i]))
    tidy_prediction_plant$.prediction[tidy_prediction_plant$.prediction<0.00001]=0
    posterior_occur_plant <- tidy_prediction_plant %>%
      group_by(.row) %>% 
      summarise(prob=sum(.prediction>0.00001)/8000)
    
    data_plant_biomass[specnames_plant[m]] <- posterior_epred_plant$median
    data_plant_occur[specnames_plant[m]] <- posterior_occur_plant$prob
  }
  #species filtering
  data_plant_biomass <- select_if(data_plant_biomass,function(col) max(col)>0.001)
  data_plant_occur <- select_if(data_plant_occur,function(col) max(col)>0.1)
  name_select_plant <- intersect(colnames(data_plant_biomass),colnames(data_plant_occur))
  data_plant_biomass <- data_plant_biomass[,name_select_plant]
  data_plant_occur <- data_plant_occur[,name_select_plant]
  
  data_plant_biomass$`Total biomass` <-apply(data_plant_biomass, 1, function(x) {exp(mean(log(x+1)))-1})
  data_plant_biomass$`Total biomass`[data_plant_biomass$`Total biomass`<0.00001]=0
  data_plant_occur$Richness <- rowSums(data_plant_occur)
  
  #benthos
  data_plot_benthos_prop <- 
    data.frame(t(apply(data_benthos_biomass[1:length(data_benthos_biomass)-1], 1, Prop_calculation)))
  colnames(data_plot_benthos_prop) <- colnames(data_benthos_biomass)[1:length(data_benthos_biomass)-1]
  
  data_plot_benthos <- 
    data.frame(apply(data_benthos_biomass, 2, standardize))
  colnames(data_plot_benthos) <- colnames(data_benthos_biomass)
  
  data_benthos_occur$Richness <-standardize(data_benthos_occur$Richness) 
  # data_plot_benthos_occur <- 
  #   data.frame(apply(data_benthos_occur, 2, standardize))
  # colnames(data_plot_benthos_occur) <- colnames(data_benthos_biomass)
  
  #niche order
  #benthos_niche_number <- apply(data_plot_benthos,2, which.max)[1:(ncol(data_plot_benthos)-1)]
  #data_benthos <- data.frame(ele_niche=ele_seq[benthos_niche_number],spe_name=colnames(data_plot_benthos)[1:(ncol(data_plot_benthos)-1)])
  #data_benthos <- arrange(data_benthos,desc(ele_niche))
  #name_order_benthos <- data_benthos$spe_name
  #saveRDS(name_order_benthos, file=paste0("./output/data/name_order_benthos_sal",i,".rds"))
  name_benthos_predict <- colnames(data_plot_benthos)
  name_order_benthos_global <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\name_order_benthos_global.rds")
  name_order_benthos_F <- name_order_benthos_global[which(name_order_benthos_global %in% name_benthos_predict)]
  #saveRDS(name_order_benthos, file=paste0("./output/data/name_high_order_benthos_sal",i,".rds"))
  
  data_plot_benthos <- data_plot_benthos[ ,c(name_order_benthos_F,"Total biomass")]
  data_plot_benthos$Elevation <-ele_seq
  
  data_plot_benthos_prop <- data_plot_benthos_prop[ ,rev(name_order_benthos_F)]
  data_plot_benthos_prop$Elevation <-ele_seq
  
  data_plot_benthos_occur <- data_benthos_occur[ ,c(name_order_benthos_F,"Richness")]
  data_plot_benthos_occur$Elevation <-ele_seq
  
  #plant
  data_plot_plant_prop <- 
    data.frame(t(apply(data_plant_biomass[1:length(data_plant_biomass)-1], 1, Prop_calculation)))
  colnames(data_plot_plant_prop) <- colnames(data_plant_biomass)[1:length(data_plant_biomass)-1]
  
  
  data_plot_plant <- 
    data.frame(apply(data_plant_biomass, 2, standardize))
  colnames(data_plot_plant) <- colnames(data_plant_biomass)
  data_plot_plant[1:16,specnames_plant[1]]<- 0
  
  data_plant_occur$Richness <- standardize(data_plant_occur$Richness)
  
  #plant_niche_number <- apply(data_plot_plant,2, which.max)[1:(ncol(data_plot_plant)-1)]
  #data_plant <- data.frame(ele_niche=ele_seq[plant_niche_number],spe_name=colnames(data_plot_plant)[1:(ncol(data_plot_plant)-1)])
  #data_plant <- arrange(data_plant,desc(ele_niche))
  #name_order_plant <- data_plant$spe_name
  #saveRDS(name_order_plant, file=paste0("./output/data/name_order_plant_sal",i,".rds"))
  name_plant_predict <- colnames(data_plot_plant)
  name_order_plant_global <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\name_order_plant_global.rds")
  name_order_plant <- name_order_plant_global[which(name_order_plant_global %in% name_plant_predict)]
  #saveRDS(name_order_plant, file=paste0("./output/data/name_high_order_plant_sal",i,".rds"))
  
  data_plot_plant <- data_plot_plant[ ,c(name_order_plant,"Total biomass")]
  data_plot_plant$Elevation <-ele_seq
  
  data_plot_plant_prop <- data_plot_plant_prop[ ,rev(name_order_plant)]
  data_plot_plant_prop$Elevation <-ele_seq
  
  data_plot_plant_occur <- data_plant_occur[ ,c(name_order_plant,"Richness")]
  data_plot_plant_occur$Elevation <-ele_seq
  
  
  
  ##melt data for plot
  data_plot_benthos_melt_F <- melt(data_plot_benthos,id='Elevation')
  data_plot_plant_melt_F <- melt(data_plot_plant,id='Elevation')
  data_plot_benthos_prop_melt_F <- melt(data_plot_benthos_prop,id='Elevation')
  data_plot_plant_prop_melt_F <- melt(data_plot_plant_prop,id='Elevation')
  data_plot_benthos_occur_melt_F <- melt(data_plot_benthos_occur,id='Elevation')
  data_plot_plant_occur_melt_F <- melt(data_plot_plant_occur,id='Elevation')
  
  data_plot_benthos_melt_F$scheme <- 'F'
  data_plot_plant_melt_F$scheme <- 'F'
  data_plot_benthos_occur_melt_F$scheme <- 'F'
  data_plot_plant_occur_melt_F$scheme <- 'F'
  
  
  ############################################################  Transitional polder  ####################################################################
  d50_seq <- d50_seq_TP
  #######preparing plot data#################
  data_benthos_biomass <- data.frame(matrix(NA, nrow = length(ele_seq), ncol =length(specnames_benthos2)))
  colnames(data_benthos_biomass) <- specnames_benthos2
  
  
  data_benthos_occur <- data.frame(matrix(NA, nrow = length(ele_seq), ncol =length(specnames_benthos2)))
  colnames(data_benthos_occur) <- specnames_benthos2 
  
  data_plant_biomass <- data.frame(matrix(NA, nrow = length(ele_seq), ncol =length(specnames_plant)))
  colnames(data_plant_biomass) <- specnames_plant
  
  
  data_plant_occur <- data.frame(matrix(NA, nrow = length(ele_seq), ncol =length(specnames_plant)))
  colnames(data_plant_occur) <- specnames_plant
  
  #benthos
  for(j in c(1,2,5:20,24)){
    eval(parse(text = paste0('load("C:/Users/xwu/R_working/workspace2/ecology model/output/model/model_bs_benthos1026/model_hurdle_salzone_bs_',j,'.Rdata")')))
    tidy_epred_benthos <- model_hurdle_salzone_bs %>% 
      epred_draws(newdata = data.frame(d50=d50_seq,em= ele_seq,salzone=sal_zone[i]),re_formula = ~ (em + d50|salzone))
    posterior_epred_benthos <- tidy_epred_benthos %>% 
      group_by(.row) %>% 
      summarise(median=median(.epred),quan95= quantile(.epred, 0.95),mean=mean(.epred),sd=sd(.epred)) %>% 
      mutate(cv=sd / mean)#overestimation
    #occurrence
    tidy_prediction_benthos <- model_hurdle_salzone_bs %>% 
      predicted_draws(newdata = data.frame(d50=d50_seq,em= ele_seq,salzone=sal_zone[i]),re_formula = ~ (em + d50|salzone))
    posterior_occur_benthos <- tidy_prediction_benthos %>% 
      group_by(.row) %>% 
      summarise(prob=sum(.prediction>0.00001)/8000)
    
    data_benthos_biomass[specnames_benthos[j]] <- posterior_epred_benthos$median
    data_benthos_occur[specnames_benthos[j]] <- posterior_occur_benthos$prob
  }
  #species filtering
  data_benthos_biomass <- select_if(data_benthos_biomass,function(col) max(col)>0.1)
  data_benthos_occur <- select_if(data_benthos_occur,function(col) max(col)>0.1)
  name_select_benthos <- intersect(colnames(data_benthos_biomass),colnames(data_benthos_occur))
  data_benthos_biomass <- data_benthos_biomass[,name_select_benthos]
  data_benthos_occur <- data_benthos_occur[,name_select_benthos]
  
  data_benthos_biomass$`Total biomass` <-apply(data_benthos_biomass, 1, function(x) {exp(mean(log(x+1)))-1})
  data_benthos_occur$Richness <- rowSums(data_benthos_occur)
  
  #plant
  eval(parse(text = paste0('inun_seq <- sapply(ele_seq,Time_to_fre',i,')')))
  for(m in 1:length(specnames_plant)){
    eval(parse(text = paste0('load("C:/Users/xwu/R_working/workspace2/ecology model/output/model/model_bs_plant/ele/model_hurdle_plant_bs_',m,'.Rdata")')))
    #abundance
    tidy_epred_plant <- model_hurdle_fit %>% 
      epred_draws(newdata = data.frame(ELEVATION=inun_seq,salzone=sal_zone[i]))
    tidy_epred_plant$.epred[tidy_epred_plant$.epred<0.00001]=0
    posterior_epred_plant <- tidy_epred_plant %>% 
      group_by(.row) %>% 
      summarise(median=median(.epred),quan95= quantile(.epred, 0.95),mean=mean(.epred),sd=sd(.epred)) %>% 
      mutate(cv=sd / mean)
    
    #occurrence
    tidy_prediction_plant <- model_hurdle_fit %>% 
      predicted_draws(newdata = data.frame(ELEVATION=inun_seq,salzone=sal_zone[i]))
    tidy_prediction_plant$.prediction[tidy_prediction_plant$.prediction<0.00001]=0
    posterior_occur_plant <- tidy_prediction_plant %>%
      group_by(.row) %>% 
      summarise(prob=sum(.prediction>0.00001)/8000)
    
    data_plant_biomass[specnames_plant[m]] <- posterior_epred_plant$median
    data_plant_occur[specnames_plant[m]] <- posterior_occur_plant$prob
  }
  #species filtering
  data_plant_biomass <- select_if(data_plant_biomass,function(col) max(col)>0.001)
  data_plant_occur <- select_if(data_plant_occur,function(col) max(col)>0.1)
  name_select_plant <- intersect(colnames(data_plant_biomass),colnames(data_plant_occur))
  data_plant_biomass <- data_plant_biomass[,name_select_plant]
  data_plant_occur <- data_plant_occur[,name_select_plant]
  
  data_plant_biomass$`Total biomass` <-apply(data_plant_biomass, 1, function(x) {exp(mean(log(x+1)))-1})
  data_plant_occur$Richness <- rowSums(data_plant_occur)
  
  #benthos
  data_plot_benthos_prop <- 
    data.frame(t(apply(data_benthos_biomass[1:length(data_benthos_biomass)-1], 1, Prop_calculation)))
  colnames(data_plot_benthos_prop) <- colnames(data_benthos_biomass)[1:length(data_benthos_biomass)-1]
  
  data_plot_benthos <- 
    data.frame(apply(data_benthos_biomass, 2, standardize))
  colnames(data_plot_benthos) <- colnames(data_benthos_biomass)
  
  data_benthos_occur$Richness <-standardize(data_benthos_occur$Richness) 
  # data_plot_benthos_occur <- 
  #   data.frame(apply(data_benthos_occur, 2, standardize))
  # colnames(data_plot_benthos_occur) <- colnames(data_benthos_biomass)
  
  #niche order
  #benthos_niche_number <- apply(data_plot_benthos,2, which.max)[1:(ncol(data_plot_benthos)-1)]
  #data_benthos <- data.frame(ele_niche=ele_seq[benthos_niche_number],spe_name=colnames(data_plot_benthos)[1:(ncol(data_plot_benthos)-1)])
  #data_benthos <- arrange(data_benthos,desc(ele_niche))
  #name_order_benthos <- data_benthos$spe_name
  #saveRDS(name_order_benthos, file=paste0("./output/data/name_order_benthos_sal",i,".rds"))
  name_benthos_predict <- colnames(data_plot_benthos)
  name_order_benthos_global <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\name_order_benthos_global.rds")
  name_order_benthos_TP <- name_order_benthos_global[which(name_order_benthos_global %in% name_benthos_predict)]
  #saveRDS(name_order_benthos, file=paste0("./output/data/name_high_order_benthos_sal",i,".rds"))
  
  data_plot_benthos <- data_plot_benthos[ ,c(name_order_benthos_TP,"Total biomass")]
  data_plot_benthos$Elevation <-ele_seq
  
  data_plot_benthos_prop <- data_plot_benthos_prop[ ,rev(name_order_benthos_TP)]
  data_plot_benthos_prop$Elevation <-ele_seq
  
  data_plot_benthos_occur <- data_benthos_occur[ ,c(name_order_benthos_TP,"Richness")]
  data_plot_benthos_occur$Elevation <-ele_seq
  
  #plant
  data_plot_plant_prop <- 
    data.frame(t(apply(data_plant_biomass[1:length(data_plant_biomass)-1], 1, Prop_calculation)))
  colnames(data_plot_plant_prop) <- colnames(data_plant_biomass)[1:length(data_plant_biomass)-1]
  
  
  data_plot_plant <- 
    data.frame(apply(data_plant_biomass, 2, standardize))
  colnames(data_plot_plant) <- colnames(data_plant_biomass)
  data_plot_plant[1:16,specnames_plant[1]]<- 0
  
  data_plant_occur$Richness <- standardize(data_plant_occur$Richness)
  
  #plant_niche_number <- apply(data_plot_plant,2, which.max)[1:(ncol(data_plot_plant)-1)]
  #data_plant <- data.frame(ele_niche=ele_seq[plant_niche_number],spe_name=colnames(data_plot_plant)[1:(ncol(data_plot_plant)-1)])
  #data_plant <- arrange(data_plant,desc(ele_niche))
  #name_order_plant <- data_plant$spe_name
  #saveRDS(name_order_plant, file=paste0("./output/data/name_order_plant_sal",i,".rds"))
  name_plant_predict <- colnames(data_plot_plant)
  name_order_plant_global <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\name_order_plant_global.rds")
  name_order_plant <- name_order_plant_global[which(name_order_plant_global %in% name_plant_predict)]
  #saveRDS(name_order_plant, file=paste0("./output/data/name_high_order_plant_sal",i,".rds"))
  
  data_plot_plant <- data_plot_plant[ ,c(name_order_plant,"Total biomass")]
  data_plot_plant$Elevation <-ele_seq
  
  data_plot_plant_prop <- data_plot_plant_prop[ ,rev(name_order_plant)]
  data_plot_plant_prop$Elevation <-ele_seq
  
  data_plot_plant_occur <- data_plant_occur[ ,c(name_order_plant,"Richness")]
  data_plot_plant_occur$Elevation <-ele_seq
  
  
  
  ##melt data for plot
  data_plot_benthos_melt_TP <- melt(data_plot_benthos,id='Elevation')
  data_plot_plant_melt_TP <- melt(data_plot_plant,id='Elevation')
  data_plot_benthos_prop_melt_TP <- melt(data_plot_benthos_prop,id='Elevation')
  data_plot_plant_prop_melt_TP <- melt(data_plot_plant_prop,id='Elevation')
  data_plot_benthos_occur_melt_TP <- melt(data_plot_benthos_occur,id='Elevation')
  data_plot_plant_occur_melt_TP <- melt(data_plot_plant_occur,id='Elevation')
  
  data_plot_benthos_melt_TP$scheme <- 'TP'
  data_plot_plant_melt_TP$scheme <- 'TP'
  data_plot_benthos_occur_melt_TP$scheme <- 'TP'
  data_plot_plant_occur_melt_TP$scheme <- 'TP'
  
  data_plot_benthos_melt <- rbind(data_plot_benthos_melt_F,data_plot_benthos_melt_TP)
  data_plot_plant_melt<- data_plot_plant_melt_F
  data_plot_benthos_occur_melt<- rbind(data_plot_benthos_occur_melt_F,data_plot_benthos_occur_melt_TP)
  data_plot_plant_occur_melt<- data_plot_plant_occur_melt_F
  
  color_benthos <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\color_benthos_global.rds")
  color_plant <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\color_plant_global.rds")
  color_benthos <- setNames(c(color_benthos, "#3399FF", "#3399FF"), c(names(color_benthos), "Total biomass", "Richness"))
  color_plant <-setNames(c(color_plant, "#009966", "#009966"), c(names(color_plant), "Total biomass", "Richness"))
  
  name_order_benthos <- unique(c(name_order_benthos_F,name_order_benthos_TP))
  data_plot_benthos_melt$variable <- factor(data_plot_benthos_melt$variable, levels = c(name_order_benthos, "Total biomass"))
  
  ######biomass######
  p_benthos <- ggplot(data_plot_benthos_melt) + 
    geom_ridgeline(mapping=aes(Elevation, variable, height = value, group = interaction(variable, scheme),fill=variable,linetype=scheme),alpha = 0.7,size=3,scale = 0.8)+
    scale_y_discrete(
      name = " "
    )+
    
    scale_x_reverse(
      name = "Inundation time",
      limits = c(1,0.15)
    )+#limits = c(0.15,1)
    scale_fill_manual(values = color_benthos, name = " ")+
    scale_linetype_manual(values=c("dotted", "solid"))+
    theme_classic()+
    theme(
      axis.text.y = element_text(size=70,color="black",margin = margin(t = 0, r = 12, b = 0, l = 0),face = "italic"),
      axis.text.x = element_text(size=70,color="black",margin = margin(t = 12, r = 0, b = 0, l = 0)),
      axis.title.x = element_text(size=70,color="black",margin = margin(t = 12, r = 0, b = 0, l = 0)),
      axis.line = element_line(colour = 'black', size = 1),
      axis.ticks = element_line(colour = "black", size = 1),
      legend.position = "none",
      legend.text = element_text(size = 30,face = "italic"),
      plot.margin = margin(5, 1, 1, 1, "mm") # Set margins for the entire plot
    ) 
  
  p_plant <- ggplot(data_plot_plant_melt) + 
    geom_ridgeline(mapping=aes(Elevation, variable, height = value, group = variable,fill=variable),size = 0,scale = 0.8)+#,alpha = 1
    scale_y_discrete(
      name = "",
      position="right"
    )+
    
    scale_x_reverse(
      name = "Inundation time",
      limits = c(0.25,0),
      breaks=c(0.25,0)
    )+
    scale_fill_manual(values = color_plant, name = " ")+
    theme_classic()+
    theme(
      axis.text.y = element_text(size=70,color="black",margin = margin(t = 0, r = 12, b = 0, l = 0),face = "italic"),
      axis.text.x = element_text(size=70,color="black",margin = margin(t = 12, r = 0, b = 0, l = 0)),
      axis.title.x = element_text(size=70,color="black",margin = margin(t = 12, r = 0, b = 0, l = 0)),
      axis.line = element_line(colour = 'black', size = 1),
      axis.ticks = element_line(colour = "black", size = 1),
      legend.position = "none",
      legend.text = element_text(size = 30,face = "italic"),
      plot.margin = margin(5, 1, 1, 1, "mm") # Set margins for the entire plot
    )
  
  p <- grid.arrange(p_benthos,p_plant, widths=c(0.6, 0.4), ncol=2, nrow=1)
  
  
  ggsave(p, file=paste0("./output/figure/elevation_niche/0904/ele_niche_overlap_sal",i,".png"), width = 100, height = 65, units = "cm")
  
  
  
  ######richness######
  data_plot_benthos_occur_melt$variable <- factor(data_plot_benthos_occur_melt$variable, levels = c(name_order_benthos, "Richness"))
  
  p_occur_benthos <- ggplot(data_plot_benthos_occur_melt) + 
    geom_ridgeline(mapping=aes(Elevation, variable, height = value, group = interaction(variable, scheme),fill=variable,linetype=scheme),alpha = 0.7,size=3,scale = 0.8)+
    scale_y_discrete(
      name = " "
    )+
    
    scale_x_reverse(
      name = "Inundation time",
      limits = c(1,0.15)
    )+
    scale_fill_manual(values = color_benthos, name = " ")+
    scale_linetype_manual(values=c("dotted", "solid"))+
    theme_classic()+
    theme(
      
      axis.text.y = element_text(size=70,color="black",margin = margin(t = 0, r = 12, b = 0, l = 0),face = "italic"),
      axis.text.x = element_text(size=70,color="black",margin = margin(t = 12, r = 0, b = 0, l = 0)),
      axis.title.x = element_text(size=70,color="black",margin = margin(t = 12, r = 0, b = 0, l = 0)),
      axis.line = element_line(colour = 'black', size = 1),
      axis.ticks = element_line(colour = "black", size = 1),
      legend.position = "none",
      legend.text = element_text(size = 30,face = "italic"),
      plot.margin = margin(5, 1, 1, 1, "mm") # Set margins for the entire plot
    ) 
  
  p_occur_plant <- ggplot(data_plot_plant_occur_melt) + 
    geom_ridgeline(mapping=aes(Elevation, variable, height = value, group = variable,fill=variable),size = 0,scale = 0.8)+
    scale_y_discrete(
      name = "",
      position="right"
    )+
    
    scale_x_reverse(
      name = "Inundation time",
      limits = c(0.27,0),
      breaks=c(0.25,0)
    )+
    scale_fill_manual(values = color_plant, name = " ")+
    theme_classic()+
    theme(
      axis.text.y = element_text(size=70,color="black",margin = margin(t = 0, r = 12, b = 0, l = 0),face = "italic"),
      axis.text.x = element_text(size=70,color="black",margin = margin(t = 12, r = 0, b = 0, l = 0)),
      axis.title.x = element_text(size=70,color="black",margin = margin(t = 12, r = 0, b = 0, l = 0)),
      axis.line = element_line(colour = 'black', size = 1),
      axis.ticks = element_line(colour = "black", size = 1),
      legend.position = "none",
      legend.text = element_text(size = 30,face = "italic"),
      plot.margin = margin(5, 1, 1, 1, "mm") # Set margins for the entire plot
    )
  
  p_occur <- grid.arrange(p_occur_benthos,p_occur_plant, widths=c(0.6, 0.4), ncol=2, nrow=1)
  
  ggsave(p_occur, file=paste0("./output/figure/elevation_niche/0904/ele_niche_occur_overlap_sal",i,".png"), width = 100, height = 65, units = "cm")
}