library(brms)
library(tidyverse)
library(tidybayes)
library(ggplot2)
library(posterior)
library(reshape2)


specnames <- readRDS(".\\data\\spenames_benthos.rds")
specnames2 <- specnames[c(1,2,5:20,24)]

sal_zone <- c("Sterk polyhalien","Zwak polyhalien","Mesohalien")

load(".\\data\\modlm_d50_high.Rdata")
load(".\\data\\modlm_d50_low.Rdata")

for(l in 1:3){#ssc
  for(i in 1:length(sal_zone)){#sal
    #predict data
    #eval(parse(text = paste0('vel_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/scenario_design/zone',i,'/Vel_max_zone',i,'.csv",stringsAsFactors = F)')))
    #eval(parse(text = paste0('em_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/scenario_design/zone',i,'/2000_whole/T_zone',i,'_ssc3.csv",stringsAsFactors = F)')))
    #eval(parse(text = paste0('em_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000_slope/T_zone',i,'_ssc',l,'_slr2.csv",stringsAsFactors = F)')))
    #eval(parse(text = paste0('em_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000/T_zone',i,'_ssc',l,'_slr2.csv",stringsAsFactors = F)')))
    #eval(parse(text = paste0('em_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000/T_zone',i,'_ssc',l,'_slr0.csv",stringsAsFactors = F)')))
    #eval(parse(text = paste0('em_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000_ele/T_zone',i,'_ssc',l,'_slr2_1.csv",stringsAsFactors = F)')))
    eval(parse(text = paste0('em_pre=read.csv("C:/Users/xwu/python_working/1dTidalModel/output/0926/zone',i,'/1000_slope/T_zone',i,'_ssc',l,'_slr0.csv",stringsAsFactors = F)')))
    
    #load model of species
    for(j in c(1,2,5:20,24)){
      eval(parse(text = paste0('load("C:/Users/xwu/R_working/workspace2/ecology model/output/model/model_bs_benthos1026/model_hurdle_salzone_bs_',j,'.Rdata")')))
      result_spe_median <- data.frame(matrix(NA, nrow = length(seq(1,601,6)), ncol =ncol(em_pre)-1))
      result_spe_quan95 <- data.frame(matrix(NA, nrow = length(seq(1,601,6)), ncol =ncol(em_pre)-1))
      result_spe_mean <- data.frame(matrix(NA, nrow = length(seq(1,601,6)), ncol =ncol(em_pre)-1))
      result_spe_occur <- data.frame(matrix(NA, nrow = length(seq(1,601,6)), ncol =ncol(em_pre)-1))
      result_spe_cv <- data.frame(matrix(NA, nrow = length(seq(1,601,6)), ncol =ncol(em_pre)-1))
      
      for(k in seq(1,601,6)){#Time
        em_t <- as.numeric(as.vector(em_pre[k,2:ncol(em_pre)]))
        d50_t=as.numeric(predict(modlm_d50_high,data.frame(em=em_t)))#change
        
        #abundance
        tidy_epred <- model_hurdle_salzone_bs %>% 
          epred_draws(newdata = data.frame(d50=d50_t,em= em_t,salzone=sal_zone[i]),re_formula = ~ (em + d50 |salzone))#
        posterior_epred_median <- tidy_epred %>% 
          group_by(.row) %>% 
          summarise(median=median(.epred),quan95= quantile(.epred, 0.95),mean=mean(.epred),sd=sd(.epred)) %>% 
          
        #occurrence
        tidy_prediction <- model_hurdle_salzone_bs %>% 
          predicted_draws(newdata = data.frame(d50=d50_t,em= em_t,salzone=sal_zone[i]),re_formula = ~ (em + d50|salzone))
        posterior_prediction_occur <- tidy_prediction %>% 
          group_by(.row) %>% 
          summarise(prob=sum(.prediction>0.00001)/8000) 
        
        result_spe_median[(k+5)/6,] <- posterior_epred_median$median
        result_spe_quan95[(k+5)/6,] <- posterior_epred_median$quan95
        result_spe_mean[(k+5)/6,] <- posterior_epred_median$mean
        result_spe_occur[(k+5)/6,] <- posterior_prediction_occur$prob
        
      }
      #write.csv(result_spe_median,paste0("./output/result_data/benthos_zone/0926/ssc", l,"/median_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)#/1000_slope
      #write.csv(result_spe_quan95,paste0("./output/result_data/benthos_zone/0926/ssc", l,"/quan_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)
      #write.csv(result_spe_mean,paste0("./output/result_data/benthos_zone/0926/ssc", l,"/mean_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)
      #write.csv( result_spe_occur,paste0("./output/result_data/benthos_zone/0926/ssc", l,"/occur_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)
      
      
      #write.csv(result_spe_median,paste0("./output/result_data/benthos_zone/0926/ssc", l,"/1000/100years/lowdynam/median_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)
      #write.csv(result_spe_quan95,paste0("./output/result_data/benthos_zone/0926/ssc", l,"/1000/100years/lowdynam/quan_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)
      #write.csv(result_spe_mean,paste0("./output/result_data/benthos_zone/0926/ssc", l,"/1000/100years/lowdynam/mean_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)
      #write.csv( result_spe_occur,paste0("./output/result_data/benthos_zone/0926/ssc", l,"/1000/100years/lowdynam/occur_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)
      
      
      write.csv(result_spe_median,paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slope_slr0/median_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)
      write.csv(result_spe_quan95,paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slope_slr0/quan_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)
      write.csv(result_spe_mean,paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slope_slr0/mean_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)
      write.csv( result_spe_occur,paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_slope_slr0/occur_bs_sal", i,"_spe",j,".csv"),row.names=FALSE)
      
      
      # write.csv(result_spe_median,paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_ele/median_bs_sal", i,"_spe",j,"_1.csv"),row.names=FALSE)
      # write.csv(result_spe_quan95,paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_ele/quan_bs_sal", i,"_spe",j,"_1.csv"),row.names=FALSE)
      # write.csv(result_spe_mean,paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_ele/mean_bs_sal", i,"_spe",j,"_1.csv"),row.names=FALSE)
      # write.csv( result_spe_occur,paste0("./output/result_data/benthos_zone/1026/ssc", l,"/1000_ele/occur_bs_sal", i,"_spe",j,"_1.csv"),row.names=FALSE)
      
    }
    
  }
}
