library(ggplot2)
library(reshape2)
library(RColorBrewer)

specnames_benthos <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\spenames_bs.rds")
specnames_benthos2 <- specnames_benthos[c(1,2,5:20,24)]
specnames_plant <- readRDS("C:\\Users\\xwu\\R_working\\workspace2\\ecology model\\output\\data\\specnames_plant.rds")


for(i in 1:3){#ssc
  for(j in 1:3){#sal
    
    Prop_time<- data.frame(matrix(0, nrow = 100, ncol =2))
    
    for(t in 1:100){#time 100 years
      
      #benthos
      result_benthos_t <- data.frame(matrix(NA, nrow = 200, ncol =length(specnames_benthos2)))
      colnames(result_benthos_t)<-specnames_benthos2
      for(l in c(1,2,5:20,24)){
        #result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc",i,"/1000/logistic/logistic_spe",l,"_sal",j,".csv"))
        #result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc",i,"/1000_slr0/logistic/logistic_spe",l,"_sal",j,".csv"))
        #result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc",i,"/1000_ele/logistic/logistic_spe",l,"_sal",j,"_1.csv"))
        result_benthos <- read.csv(paste0("./output/result_data/benthos_zone/1026/ssc",i,"/1000_slope_slr0/logistic/logistic_spe",l,"_sal",j,".csv"))
        result_benthos_t[specnames_benthos[l]] <- as.numeric(as.vector(result_benthos[t,1:200]))
      }
      total_biomass_benthos <- apply(result_benthos_t, 1, sum)
      Prop_time[t,1] <- mean(total_biomass_benthos>0.5)
      
      #plant
      result_plant_t <- data.frame(matrix(NA, nrow = 201, ncol =length(specnames_plant)))
      colnames(result_plant_t)<-specnames_plant
      for(l in 1:17){
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000/100years/lowdynam/plant_median_sal", j,"_spe",l,".csv"))
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000/plant_median_sal", j,"_spe",l,".csv"))
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000_slr0/plant_median_sal", j,"_spe",l,".csv"))
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000_slope/plant_median_sal", j,"_spe",l,".csv"))
        #result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000_ele/plant_median_sal", j,"_spe",l,"_1.csv"))
        result_plant <- read.csv(paste0("./output/result_data/plant_zone/0926/ssc", i,"/1000_slope_slr0/plant_median_sal", j,"_spe",l,".csv"))
        result_plant_t[specnames_plant[l]] <- as.numeric(as.vector(result_plant[t,]))
      }
      total_biomass_plant <- apply(result_plant_t, 1, sum)
      Prop_time[t,2] <- mean(total_biomass_plant>0)
    }
    
    Prop_plot<- data.frame(matrix(0, nrow = 100, ncol =3))
    overlap <- (Prop_time$X1+Prop_time$X2)-1
    Prop_plot$X1 <- Prop_time$X1-overlap
    Prop_plot$X2 <- overlap
    Prop_plot$X3 <- Prop_time$X2-overlap
    Prop_plot$Year <-seq(1,100,1)
    Prop_plot_melt <- melt(Prop_plot,id='Year')
    
    color <- c("#3399FF","#006666","#009966")
    p_prop <- ggplot() +
      geom_area(Prop_plot_melt, mapping=aes(Year, value, fill=variable),alpha=0.5)+
      scale_y_reverse(
        limits = c(1.01, 0),  
        name = "Proportion",
      )+
      scale_x_continuous(
        name = "Year",
      )+
      scale_fill_manual(values=color,name=" ")+
      theme_classic()+
      theme(
        axis.text = element_text(size = 70),
        axis.title.y = element_text( size=70,margin = margin(t = 0, r = 8, b = 0, l = 0)),
        axis.title.x = element_text(size=70,margin = margin(t = 10, r = 0, b = 0, l = 0)),
        legend.position = "none",
        legend.text = element_text(size = 40),
        plot.margin = unit(c(0.2,0.6,0.2,0.2), "cm")
      )+
      coord_flip()
    #ggsave(p_prop, file=paste0("./output/result_figure/together/1121/ssc", i,"/1000_ele/porp_sal",j,"_ssc",i,"_1.png"), width = 45, height = 30, units = "cm")
    #ggsave(p_prop, file=paste0("./output/result_figure/together/1121/ssc", i,"/1000/porp_sal",j,"_ssc",i,".png"), width = 45, height = 30, units = "cm")
    ggsave(p_prop, file=paste0("./output/result_figure/together/1121/ssc", i,"/1000_slope_slr0/porp_sal",j,"_ssc",i,".png"), width = 45, height = 30, units = "cm")
  }
}